##### Experiment 1; check the estimation efficiency

N=1000;  # repeat times
n1=400;  # n takes from 100, 200, 400
para=rbind(
c(n1,1,1,0,0.1,0),
c(n1,1,1,0,0.5,0),
c(n1,1,1,0,0.1,0.5),
c(n1,1,1,0,0.5,0.5),
c(n1,0.95,0.95,0,0.1,0),
c(n1,0.95,0.95,0,0.5,0),
c(n1,0.95,0.95,0,0.1,0.5),
c(n1,0.95,0.95,0,0.5,0.5),
c(n1,-0.95,-0.95,0,0.1,0),
c(n1,-0.95,-0.95,0,0.5,0),
c(n1,-0.95,-0.95,0,0.1,0.5),
c(n1,-0.95,-0.95,0,0.5,0.5),
c(n1,0,0,0,0.1,0),
c(n1,0,0,0,0.5,0),
c(n1,0,0,0,0.1,0.5),
c(n1,0,0,0,0.5,0.5)
)

dimp=dim(para)[1];

gamahat1=alpha1=alpha1se=alpha2=alpha2se=delta1=delta2=delta1se=delta2se=matrix(0,nrow=N,ncol=dimp)
gamahat2=dis11=dis12=dis21=dis22=dis_delta1=dis_delta2=matrix(0,nrow=N,ncol=dimp)
slm1=swald1=swald2=matrix(0,nrow=N,ncol=dimp)
qhat1=qhat2=qhat3=qhat4=matrix(0,nrow=N,ncol=dimp);
for(pp in 1:dimp)
{
   T=para[pp,1];  # sample size
   rou1=para[pp,2];  #persistency parameter in regime 1
   rou2=para[pp,3];  # persistency parameter in regime 2
   beta1=4*n1^(-0.5-para[pp,5]);   ### size of threshold effect, for power
   beta2=para[pp,4];  
   rou=para[pp,6];  # endogeneity parameter


# define the threshold variable q as an AR(1) process

q=rep(0,T);
ee=rnorm(T)
for(j in 2:T){
 q[j]=0.5*q[j-1]+ee[j];
 }
gama0=0  ;

for(n in 1:N){

#define error term process 
e=rnorm(T);
e1=rep(e[1],T);
for(i in 2:T){
  e1[i]=e1[i-1]*rou1*(q[i]<gama0)+e1[i-1]*rou2*(q[i]>=gama0)+e[i];
}
ex=rnorm(T);
x=cumsum(ex);
maxk=5;

bigex=NULL;
for(i in 1:maxk){
bigex=cbind(bigex,ex[i:(T-maxk+i)])
}
ex1=rep(0,T);
ex1[maxk:T]=bigex[,maxk];

y=(beta1*x+rou*ex1+e1)*(q<=gama0)+(beta2*x+rou*ex1+e1)*(q>gama0)

###
dat=cbind(y,x,q);
yi=1;
xi=2:(ncol(dat)-1);
qi=ncol(dat);

dat1=cbind(y[maxk:T],x[maxk:T],bigex,q[maxk:T]);
yi=1;
xi1=2:(ncol(dat1)-1);
qi1=ncol(dat1);

###profiled estimation 
thre1=PLS_thre(dat,1,xi,qi,h=1,intercept=0);   #primary estimation of threshold
threshold=thre1$threshold[1];
thre2=FGLS_thre(dat1,1,xi1,qi1,maxk=maxk,threshold,h=1,intercept=0);   #primary estimation of threshold, but with stationary terms
threshold=thre2$threshold[1];
rou=thre2$rou_hat;
rou=rou[length(rou)];

gamahat1[n,pp]=thre1$threshold[1];
gamahat2[n,pp]=thre2$threshold[1];

delta2[n,pp]=thre2$delta[1];
delta2se[n,pp]=thre2$delta[2];
delta1[n,pp]=thre1$delta[1];
delta1se[n,pp]=thre1$delta[2];

dis11[n,pp]=(thre1$alpha1[1]-beta1);
dis12[n,pp]=(thre1$alpha2[1]-beta2);
dis21[n,pp]=(thre2$alpha1[1]-beta1);
dis22[n,pp]=(thre2$alpha2[1]-beta2);
deta=beta1-beta2;
dis_delta1[n,pp]=(delta1[n,pp]-deta);
dis_delta2[n,pp]=(delta2[n,pp]-deta);
    }
}

## report mse
gama_mse1=gama_mse2=rep(0,16)
gama_mae1=gama_mae2=rep(0,16)
alpha_mse11=alpha_mse12=alpha_mse21=alpha_mse22=rep(0,16)
alpha_mae11=alpha_mae12=alpha_mae21=alpha_mae22=rep(0,16)
delta_mse2=delta_mse1=rep(0,16);
delta_mae2=delta_mae1=rep(0,16);

for(pp in 1:16){
gama_mse1[pp]=mean(gamahat1[,pp]^2)
gama_mse2[pp]=mean(gamahat2[,pp]^2)

gama_mae1[pp]=mean(abs(gamahat1[,pp]))
gama_mae2[pp]=mean(abs(gamahat2[,pp]))

alpha_mse11[pp]=mean(dis11[,pp]^2);
alpha_mse12[pp]=mean(dis12[,pp]^2);
alpha_mse21[pp]=mean(dis21[,pp]^2);
alpha_mse22[pp]=mean(dis22[,pp]^2);
delta_mse1[pp]=mean(dis_delta1[,pp]^2);
delta_mse2[pp]=mean(dis_delta2[,pp]^2);

alpha_mae11[pp]=mean(abs(dis11[,pp]));
alpha_mae12[pp]=mean(abs(dis12[,pp]));
alpha_mae21[pp]=mean(abs(dis21[,pp]));
alpha_mae22[pp]=mean(abs(dis22[,pp]));
delta_mae1[pp]=mean(abs(dis_delta1[,pp]));
delta_mae2[pp]=mean(abs(dis_delta2[,pp]));
}

mse=cbind(gama_mse1,gama_mse2,alpha_mse11,alpha_mse12,alpha_mse21,alpha_mse22,delta_mse1,delta_mse2);
mse1=cbind(para,mse);
mae=cbind(gama_mae1,gama_mae2,alpha_mae11,alpha_mae12,alpha_mae21,alpha_mae22,delta_mae1,delta_mae2);
mae1=cbind(para,mae);
alpha_mse1=alpha_mse11+delta_mse1;
alpha_mse2=alpha_mse21+delta_mse2;
alpha_mae1=alpha_mae11+delta_mae1;
alpha_mae2=alpha_mae21+delta_mae2;
mmse1=cbind(para,gama_mse1,gama_mse2,alpha_mse1,alpha_mse2)
mmae1=cbind(para,gama_mae1,gama_mae2,alpha_mae1,alpha_mae2)

write.csv(mse1,file="mse2013_T400_N1000.csv")
write.csv(mae1,file="mae2013_T400_N1000.csv")
write.csv(mmse1,file="mmse2013_T400_N1000.csv")
write.csv(mmae1,file="mmae2013_T400_N1000.csv")

save.image(file="exp1_2013_T400_N1000.rdata")




